VERSION 5.00
Object = "{86CF1D34-0C5F-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCT2.OCX"
Begin VB.Form frmConfig 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Elephant Memory - [Configuration]"
   ClientHeight    =   3630
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4800
   Icon            =   "frmConfig.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3630
   ScaleWidth      =   4800
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton btnSave 
      Caption         =   "&Save"
      Height          =   315
      Left            =   3540
      TabIndex        =   6
      Top             =   1695
      Width           =   1215
   End
   Begin VB.TextBox txtHours 
      Height          =   285
      Left            =   810
      TabIndex        =   2
      Top             =   2152
      Width           =   405
   End
   Begin VB.OptionButton optOn 
      Caption         =   "On"
      Height          =   270
      Left            =   105
      TabIndex        =   12
      TabStop         =   0   'False
      Top             =   2610
      Width           =   645
   End
   Begin VB.OptionButton optIn 
      Caption         =   "In"
      Height          =   270
      Left            =   105
      TabIndex        =   11
      TabStop         =   0   'False
      Top             =   2160
      Width           =   645
   End
   Begin MSComCtl2.DTPicker pckDate 
      Height          =   300
      Left            =   810
      TabIndex        =   4
      Top             =   2610
      Width           =   1275
      _ExtentX        =   2249
      _ExtentY        =   529
      _Version        =   393216
      Format          =   22872065
      CurrentDate     =   36852
   End
   Begin VB.TextBox txtMinutes 
      Height          =   285
      Left            =   1965
      TabIndex        =   3
      Top             =   2152
      Width           =   405
   End
   Begin VB.TextBox txtEventName 
      Height          =   285
      Left            =   810
      TabIndex        =   1
      Top             =   1695
      Width           =   2610
   End
   Begin VB.CommandButton btnDelete 
      Caption         =   "&Delete"
      Height          =   315
      Left            =   3540
      TabIndex        =   8
      Top             =   2610
      Width           =   1215
   End
   Begin VB.CommandButton btnAdd 
      Caption         =   "&Add"
      Height          =   315
      Left            =   3540
      TabIndex        =   7
      Top             =   2152
      Width           =   1215
   End
   Begin VB.ListBox lstEvents 
      Height          =   1425
      Left            =   90
      TabIndex        =   0
      Top             =   90
      Width           =   4650
   End
   Begin VB.CommandButton btnShutdown 
      Caption         =   "Shut&down"
      Height          =   495
      Left            =   105
      TabIndex        =   9
      Top             =   3060
      Width           =   1785
   End
   Begin VB.CommandButton btnClose 
      Cancel          =   -1  'True
      Caption         =   "&Close Configuration"
      Height          =   495
      Left            =   3090
      TabIndex        =   10
      Top             =   3060
      Width           =   1665
   End
   Begin VB.Timer tmrScout 
      Interval        =   15000
      Left            =   2130
      Top             =   3150
   End
   Begin MSComCtl2.DTPicker pckTime 
      Height          =   300
      Left            =   2130
      TabIndex        =   5
      Top             =   2610
      Width           =   1290
      _ExtentX        =   2275
      _ExtentY        =   529
      _Version        =   393216
      Format          =   22872066
      CurrentDate     =   36852
   End
   Begin VB.Label lblHours 
      Caption         =   "hours"
      Height          =   240
      Left            =   1335
      TabIndex        =   14
      Top             =   2190
      Width           =   420
   End
   Begin VB.Label lblMinutes 
      Caption         =   "minutes"
      Height          =   240
      Left            =   2520
      TabIndex        =   15
      Top             =   2190
      Width           =   645
   End
   Begin VB.Label lblName 
      Caption         =   "Name"
      Height          =   225
      Left            =   105
      TabIndex        =   13
      Top             =   1740
      Width           =   450
   End
End
Attribute VB_Name = "frmConfig"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim m_events As iCollection
Implements iReminderListener

Private WithEvents m_frmSysTray As frmSysTray
Attribute m_frmSysTray.VB_VarHelpID = -1

Private Function GetTriggerTime() As cDateTime
Dim aDateTime As cDateTime

   Set aDateTime = New cDateTime
   If optOn.value Then
      With aDateTime
         .Annees = pckDate.Year
         .Mois = pckDate.Month
         .Jours = pckDate.Day
         .Heures = pckTime.Hour
         .Minutes = pckTime.Minute
      End With
   ElseIf optIn.value Then
      aDateTime.SetToday
      aDateTime.AddTo txtMinutes.Text, txtHours.Text
   End If
   Set GetTriggerTime = aDateTime
   Set aDateTime = Nothing

End Function

Private Sub btnAdd_Click()
Dim anEvent As cEvent

   Set anEvent = New cEvent
   anEvent.Name = txtEventName.Text
   Set anEvent.TriggerTime = GetTriggerTime()
   lstEvents.AddItem anEvent.Name & " @ " & anEvent.TriggerTime.PrintOn()
   m_events.Add anEvent
   Set anEvent = Nothing
   SaveSettings
   RefreshList

End Sub

Private Sub btnClose_Click()
   Me.Hide
End Sub

Private Sub btnDelete_Click()
Dim Index As Long

   Index = lstEvents.ListIndex + 1
   m_events.Remove Index
   SaveSettings
   RefreshList

End Sub

Private Sub btnSave_Click()
Dim anEvent As cEvent

   Set anEvent = m_events.Item(lstEvents.ListIndex + 1)
   anEvent.Name = txtEventName.Text
   Set anEvent.TriggerTime = GetTriggerTime()
   Set anEvent = Nothing
   SaveSettings
   RefreshList

End Sub

Private Sub btnShutdown_Click()
   Unload Me
End Sub

Private Sub Form_Load()

   Set m_frmSysTray = New frmSysTray
   With m_frmSysTray
      .AddMenuItem "&Configure", "open", True
      .AddMenuItem "&Shutdown", "shutdown"
      .ToolTip = appName
      .IconHandle = Me.Icon.Handle
   End With

   Me.Caption = appName & " [" & section & "]"
   Me.Hide

   LoadSettings
   tmrScout_Timer

End Sub

Private Sub ShowMe()

   Me.Show
   Me.ZOrder

   RefreshList

End Sub

Private Sub RefreshList()
Dim enumerator As iEnumerator, anEvent As cEvent

   optIn.value = True
   txtEventName.Text = ""
   pckDate.value = Date
   pckTime.value = time
   txtHours.Text = 0
   txtMinutes.Text = 15

   btnAdd.Enabled = False
   btnDelete.Enabled = False
   btnSave.Enabled = False
   lstEvents.Clear

   Set enumerator = m_events.getEnumerator
   Do While enumerator.GetNext(anEvent)
      lstEvents.AddItem anEvent.Name & " @ " & anEvent.TriggerTime.PrintOn
   Loop

End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
Dim realUnload As QueryUnloadConstants

   realUnload = UnloadMode
   If realUnload = vbFormControlMenu Then
      Cancel = True
      Me.Hide
   Else
      Unload m_frmSysTray
      Set m_frmSysTray = Nothing
   End If

End Sub

Private Sub iReminderListener_Dismissed(anEvent As cEvent)
Dim current As cEvent, c As Long, enumerator As iEnumerator

   ' find and remove this event
   c = 1
   Set enumerator = m_events.getEnumerator
   Do While enumerator.GetNext(current)
      If current Is anEvent Then
         m_events.Remove c
         Exit Do
      End If
      c = c + 1
   Loop
   SaveSettings
   RefreshList

End Sub

Private Sub iReminderListener_Snoozed(anEvent As cEvent)

   anEvent.TriggerTime.SetToday
   anEvent.TriggerTime.AddTo 15
   anEvent.Triggered = False
   SaveSettings
   RefreshList

End Sub

Private Sub lstEvents_Click()
Dim anEvent As cEvent, Index As Long

   Index = lstEvents.ListIndex
   btnSave.Enabled = (Index <> -1)
   btnDelete.Enabled = btnSave.Enabled
   If btnSave.Enabled Then
      Set anEvent = m_events.Item(Index + 1)
      txtEventName = anEvent.Name
      With anEvent.TriggerTime
         pckDate.Year = .Annees
         pckDate.Month = .Mois
         pckDate.Day = .Jours
         pckTime.Hour = .Heures
         pckTime.Minute = .Minutes
         pckTime.Second = 0
      End With
      optOn.value = True
   End If

End Sub

Private Sub m_frmSysTray_MenuClick(ByVal lIndex As Long, ByVal sKey As String)
   Select Case sKey
      Case "open"
         ShowMe
      Case "shutdown"
         Unload Me
   End Select
End Sub

Private Sub m_frmSysTray_SysTrayDoubleClick(ByVal eButton As MouseButtonConstants)
   ShowMe
End Sub

Private Sub m_frmSysTray_SysTrayMouseDown(ByVal eButton As MouseButtonConstants)
   If eButton = vbRightButton Then
      m_frmSysTray.ShowMenu
   End If
End Sub

Private Sub pckDate_Change()
   optOn.value = True
End Sub

Private Sub pckTime_Change()
   optOn.value = True
End Sub

Private Sub tmrScout_Timer()
Dim aDateTime As cDateTime, anEvent As cEvent, aReminder As frmReminder, c As Long
Dim enumerator As iEnumerator

   Set aDateTime = New cDateTime
   aDateTime.SetToday

   c = 1
   Set enumerator = m_events.getEnumerator
   Do While enumerator.GetNext(anEvent)
      If aDateTime.IsEqualTo(anEvent.TriggerTime) Or aDateTime.IsGreaterThan(anEvent.TriggerTime) Then
         If Not anEvent.Triggered Then
            Set aReminder = New frmReminder
            aReminder.InvokeWith anEvent, Me
            anEvent.Triggered = True
         End If
      End If
      c = c + 1
   Loop

End Sub

Private Sub txtEventName_Change()
   btnAdd.Enabled = (Len(Trim$(txtEventName.Text)) > 0)
End Sub

Private Sub txtHours_Change()
   optIn.value = True
End Sub

Private Sub txtMinutes_Change()
   optIn.value = True
End Sub

Private Sub LoadSettings()
Dim hFile As Long, count As Long, c As Long
Dim anEvent As cEvent

   Set m_events = New LinkedList
   hFile = FreeFile
   Open App.Path & "\events.txt" For Input As #hFile
      Input #hFile, count
      For c = 1 To count
         Set anEvent = New cEvent
         anEvent.Load hFile
         m_events.Add anEvent
      Next
   Close #hFile

End Sub

Private Sub SaveSettings()
Dim hFile As Long, count As Long, c As Long
Dim anEvent As cEvent, enumerator As iEnumerator

   Screen.MousePointer = vbHourglass

   hFile = FreeFile
   Open App.Path & "\events.txt" For Output As #hFile
      count = m_events.count
      Print #hFile, count
      Set enumerator = m_events.getEnumerator
      Do While enumerator.GetNext(anEvent)
         anEvent.Save hFile
      Loop
   Close #hFile

   Screen.MousePointer = vbArrow

End Sub
